####
#
# Installs bitcoind from source
#
class bitcoind::source
{
    include bitcoind::params
    notify{'Starting build of bitcoind.': }
    # 1GB SWAPFILE CODE
    # sudo dd if=/dev/zero of=/swapfile bs=64M count=16
    # sudo mkswap /swapfile
    # sudo swapon /swapfile
    $repository = 'git://github.com/bitcoin/bitcoin.git'
    $requires   = [
        'git',
        'build-essential',
        'libssl-dev',
        'libdb5.1-dev',
        'libdb++-dev',
        'libboost1.49-all-dev',
        'libboost1.49-dbg',
        'libboost-all-dev',
        'libminiupnpc5',
        'libminiupnpc-dev'
    ]
    $clone_path = '/opt/bitcoin'
    $install_path = '/opt/data/crypto/btc/data/bin/'
    package { $requires:
        ensure => present,
    }
    file { $clone_path:
        ensure => directory,
    }
    exec { 'git clone bitcoin':
        path      => '/usr/local/bin:/usr/local/sbin:/usr/X11R6/bin:/usr/bin:/usr/sbin:/bin:/opt/data/crypto/btc/data/bin/:/sbin:.',
        command   => "git clone ${repository} ${clone_path}",
        creates   => "${clone_path}/.git",
        logoutput => true
    }
    exec { 'make bitcoin':
        path      => '/usr/local/bin:/usr/local/sbin:/usr/X11R6/bin:/usr/bin:/usr/sbin:/bin:/sbin:.',
        command   => './autogen.sh && ./configure && make',
        creates   => "${clone_path}/src/bitcoind",
        cwd       => "${clone_path}/src",
        logoutput => true,
        timeout   => 0,
    }
    exec { 'copy binary':
        path      => '/usr/local/bin:/usr/local/sbin:/usr/X11R6/bin:/usr/bin:/usr/sbin:/bin:/sbin:.',
        command   => "cp ${clone_path}/src/bitcoind ${install_path}",
        creates   => "${install_path}/bitcoind",
        logoutput => true
    }
}
